/* Component header. */
#include "component_header.h"

/* Dynamic loader. */
#include "dynamic_loader.h"

extern uint32_t _sidata[];
extern uint32_t _sdata[];
extern uint32_t _edata[];
extern uint32_t _sbss[];
extern uint32_t _ebss[];

/* Application entry point. */
extern void vStartApplication( void );

/* Application is not exporting any function. */
function_definition_t exported_functions[] __attribute__ ((section(".exported_functions"))) =
{
    { 0, 0 }
};
/*-----------------------------------------------------------*/

isr_definition_t required_isrs[] __attribute__ ((section(".required_isrs"))) =
{
    { 0, 0 }
};
/*-----------------------------------------------------------*/

component_header_t header __attribute__ ((section(".component_header"))) = 
{
    .component_id           = APPLICATION_ID,
    .data_rom_start         = ( uint32_t ) _sidata,
    .data_ram_start         = ( uint32_t ) _sdata,
    .data_ram_end           = ( uint32_t ) _edata,
    .bss_ram_start          = ( uint32_t ) _sbss,
    .bss_ram_end            = ( uint32_t ) _ebss,
    .entry_point            = ( uint32_t ) vStartApplication,
    .function_table_start   = ( uint32_t ) exported_functions,
    .isr_table_start        = ( uint32_t ) required_isrs,
};
/*-----------------------------------------------------------*/
