/* HAL includes. */
#include "stm32l4xx_hal.h"
#include "get_core_clock.h"

/* Function Ids. */
#include "bsp_function_ids.h"

/* Dynamic loader. */
#include "dynamic_loader.h"

void HAL_GPIO_Init( GPIO_TypeDef * GPIOx, GPIO_InitTypeDef * GPIO_Init )
{
    typedef void ( * HAL_GPIO_Init_t )( GPIO_TypeDef * GPIOx, GPIO_InitTypeDef * GPIO_Init );

    HAL_GPIO_Init_t HAL_GPIO_Init_addr = ( HAL_GPIO_Init_t ) GET_PROC_ADDRESS( BSP_ID, HAL_GPIO_Init_ID );

    HAL_GPIO_Init_addr( GPIOx, GPIO_Init );
}
/*-----------------------------------------------------------*/

void HAL_GPIO_TogglePin( GPIO_TypeDef * GPIOx, uint16_t GPIO_Pin )
{
    typedef void ( * HAL_GPIO_TogglePin_t )( GPIO_TypeDef * GPIOx, uint16_t GPIO_Pin );

    HAL_GPIO_TogglePin_t HAL_GPIO_TogglePin_addr = ( HAL_GPIO_TogglePin_t ) GET_PROC_ADDRESS( BSP_ID, HAL_GPIO_TogglePin_ID );

    HAL_GPIO_TogglePin_addr( GPIOx, GPIO_Pin );
}
/*-----------------------------------------------------------*/

void HAL_GPIO_WritePin( GPIO_TypeDef* GPIOx, uint16_t GPIO_Pin, GPIO_PinState PinState )
{
    typedef void ( * HAL_GPIO_WritePin_t )( GPIO_TypeDef* GPIOx, uint16_t GPIO_Pin, GPIO_PinState PinState );

    HAL_GPIO_WritePin_t HAL_GPIO_WritePin_addr = ( HAL_GPIO_WritePin_t ) GET_PROC_ADDRESS( BSP_ID, HAL_GPIO_WritePin_ID );

    HAL_GPIO_WritePin_addr( GPIOx, GPIO_Pin, PinState );
}
/*-----------------------------------------------------------*/

uint32_t GetSystemCoreClock( void )
{
    uint32_t ret;
    typedef uint32_t ( * GetSystemCoreClock_t )( void );

    GetSystemCoreClock_t GetSystemCoreClock_addr = ( GetSystemCoreClock_t ) GET_PROC_ADDRESS( BSP_ID, GetSystemCoreClock_ID );

    ret = GetSystemCoreClock_addr();
    return ret;
}
/*-----------------------------------------------------------*/

void InitializeHardware( void )
{
    typedef void ( * InitializeHardware_t )( void );

    InitializeHardware_t InitializeHardware_addr = ( InitializeHardware_t ) GET_PROC_ADDRESS( BSP_ID, InitializeHardware_ID );

    InitializeHardware_addr();
}
/*-----------------------------------------------------------*/
