/* HAL includes. */
#include "stm32l4xx_hal.h"

/* Setup related includes. */
#include "initialize.h"
#include "get_core_clock.h"

/* ISR declarations. */
#include "stm32l4xx_it.h"

/* Function Ids. */
#include "bsp_function_ids.h"

/* Component header. */
#include "component_header.h"

/* Dynamic loader. */
#include "dynamic_loader.h"

extern uint32_t _sidata[];
extern uint32_t _sdata[];
extern uint32_t _edata[];
extern uint32_t _sbss[];
extern uint32_t _ebss[];

function_definition_t exported_functions[] __attribute__ ((section(".exported_functions"))) =
{
    { HAL_GPIO_Init_ID,         ( uint32_t ) HAL_GPIO_Init          },
    { HAL_GPIO_TogglePin_ID,    ( uint32_t ) HAL_GPIO_TogglePin     },
    { HAL_GPIO_WritePin_ID,     ( uint32_t ) HAL_GPIO_WritePin      },
    { GetSystemCoreClock_ID,    ( uint32_t ) GetSystemCoreClock     },
    { InitializeHardware_ID,    ( uint32_t ) InitializeHardware     },
    { 0,                        0                                   },
};
/*-----------------------------------------------------------*/

isr_definition_t required_isrs[] __attribute__ ((section(".required_isrs"))) =
{
    { NMI_Handler_ID,           ( uint32_t ) NMI_Handler            },
    { HardFault_Handler_ID,     ( uint32_t ) HardFault_Handler      },
    { MemManage_Handler_ID,     ( uint32_t ) MemManage_Handler      },
    { BusFault_Handler_ID,      ( uint32_t ) BusFault_Handler       },
    { UsageFault_Handler_ID,    ( uint32_t ) UsageFault_Handler     },
    { DebugMon_Handler_ID,      ( uint32_t ) DebugMon_Handler       },
    { EXTI9_5_IRQHandler_ID,    ( uint32_t ) EXTI9_5_IRQHandler     },
    { EXTI15_10_IRQHandler_ID,  ( uint32_t ) EXTI15_10_IRQHandler   },
    { TIM6_DAC_IRQHandler_ID,   ( uint32_t ) TIM6_DAC_IRQHandler    },
    { 0,                        0                                   },
};
/*-----------------------------------------------------------*/

component_header_t header __attribute__ ((section(".component_header"))) = 
{
    .component_id           = BSP_ID,
    .data_rom_start         = ( uint32_t ) _sidata,
    .data_ram_start         = ( uint32_t ) _sdata,
    .data_ram_end           = ( uint32_t ) _edata,
    .bss_ram_start          = ( uint32_t ) _sbss,
    .bss_ram_end            = ( uint32_t ) _ebss,
    .entry_point            = 0,
    .function_table_start   = ( uint32_t ) exported_functions,
    .isr_table_start        = ( uint32_t ) required_isrs,
};
/*-----------------------------------------------------------*/
