/* FreeRTOS includes. */
#include "FreeRTOS.h"
#include "task.h"

/* Function Ids. */
#include "freertos_function_ids.h"

/* Dynamic loader. */
#include "dynamic_loader.h"

BaseType_t xTaskCreate( TaskFunction_t pxTaskCode,
                        const char * const pcName,
                        const configSTACK_DEPTH_TYPE usStackDepth,
                        void * const pvParameters,
                        UBaseType_t uxPriority,
                        TaskHandle_t * const pxCreatedTask )
{
    BaseType_t ret;

    typedef  BaseType_t ( * xTaskCreate_t )( TaskFunction_t pxTaskCode,
                                             const char * const pcName,
                                             const configSTACK_DEPTH_TYPE usStackDepth,
                                             void * const pvParameters,
                                             UBaseType_t uxPriority,
                                             TaskHandle_t * const pxCreatedTask );

    xTaskCreate_t xTaskCreate_addr = ( xTaskCreate_t ) GET_PROC_ADDRESS( FREERTOS_ID, xTaskCreateID );

    ret = xTaskCreate_addr( pxTaskCode,
                            pcName,
                            usStackDepth,
                            pvParameters,
                            uxPriority,
                            pxCreatedTask );

    return ret;
}
/*-----------------------------------------------------------*/

void vTaskStartScheduler( void )
{
    typedef void ( * vTaskStartScheduler_t )( void );

    vTaskStartScheduler_t vTaskStartScheduler_addr = ( vTaskStartScheduler_t ) GET_PROC_ADDRESS( FREERTOS_ID, vTaskStartSchedulerID );

    vTaskStartScheduler_addr();
}
/*-----------------------------------------------------------*/

void vTaskDelay( const TickType_t xTicksToDelay )
{
    typedef void ( * vTaskDelay_t )( const TickType_t xTicksToDelay );

    vTaskDelay_t vTaskDelay_addr = ( vTaskDelay_t ) GET_PROC_ADDRESS( FREERTOS_ID, vTaskDelayID );

    vTaskDelay_addr( xTicksToDelay );
}
/*-----------------------------------------------------------*/
